<?php

// +----------------------------------------------------------------------
// | JiZhiCMS { 极致CMS，给您极致的建站体验 }  
// +----------------------------------------------------------------------
// | Copyright (c) 2018-2099 http://www.jizhicms.com All rights reserved.
// +----------------------------------------------------------------------
// | Author: 留恋风 <2581047041@qq.com>
// +----------------------------------------------------------------------
// | Date：2022/03/18
// +----------------------------------------------------------------------


namespace app\home\plugins;

use app\home\c\CommonController;
use frphp\extend\Page;
use frphp\extend\ArrayPage;

class IndexController extends CommonController
{
    
    public $config = [
          'db_host' => 'localhost',//或者127.0.0.1 或指定的数据库地址
            'db_port' => 3306,//默认mysql数据库端口
            'db_name' => 'xx',//数据库名字
            'db_user' => 'xx',//数据库用户名
            'db_pass' => 'xxxx',//数据库密码
        	'db_prefix' => 'dede_',//表前缀
        ];
	
	public function index(){
		echo '<div style="text-align: center;">';
		echo '<h2>dedecms数据库转换成极致CMS控制器</h2>
  <i>by 如沐春 2581047041@qq.com</i><br>

<p><h3>使用说明：本插件只是为了将织梦的数据库里面的栏目及文章转化成极致CMS内的栏目和文章，模板还需自己使用极致CMS的标签手动替换！</h3></p>';
		echo '<ol style="text-align: left;
    padding: 0 28%;"><li><h4>使用前必须安装一个空的极致CMS网站。（不能导入测试数据，必须是空的数据库）</h4></li>';
		echo '<li><h4>进入极致CMS网站后台---系统配置--高级配置--开启层级URL --选择【是】</h4></li>';
		echo "<li><h4>进入文件Home/plugins/IndexController.php <br>
		里面配置你需要转换的数据库（注意：不是当前的极致CMS，而是dede的数据库连接）<br>
 public \$config = [<br>
          'db_host' => 'localhost',//或者127.0.0.1 或指定的数据库地址<br>
            'db_port' => 3306,//默认mysql数据库端口<br>
            'db_name' => 'xxx',//数据库名字<br>
            'db_user' => 'xxx',//数据库用户名<br>
            'db_pass' => 'xxxx',//数据库密码<br>
        	'db_prefix' => 'dede_',//表前缀<br>
        ];</h4>
		<a target='_blank' href='/index/connectmysql' >【测试数据库连接】</a>
		</li>";
		echo '<li><h4>导入dedecms的栏目数据<a href="/index/lanmu" target="_blank">【点击导入】</a></h4>';
		echo '<i style="color:#F00;">Tips: 如果栏目导入没有提示导入成功，那么可能你的dede数据库中的栏目名字长度太长，可以查看Cache/log/下面的错误文件，会提示SQL错误。去极致的数据库中jz_classtype里面将classname和seo_classname的长度改成255即可。<br>有错误后需要清空栏目数据！<b>[<a href=\'javascript:if(confirm("您确定栏目有错误？清空栏目数据后不可恢复！")) window.location.href="/index/clearlanmu";\'>点击清空栏目数据</a>]</b></i>
		</li>';
		echo '<li><h4>导入dedecms内容数据，时间可能比较长，每次导入500条，2s后自动刷新。<a href="/index/body" target="_blank">【点击导入】</a></h4>
		<i style="color:#F00;">Tips: 如果导入时间过长，显示空白，没有内容显示，说明有错误。查看Cache/log/下面的错误信息，根据SQL错误进行修改。导入有错误，可以修改错误后，清空数据库内数据，再进行导入<b>[<a href=\'javascript:if(confirm("您确定内容有错误？清空内容数据后不可恢复！")) window.location.href="/index/clearbody";\'>点击清空内容数据</a>]</b></i>
		
		</li>';
		echo '<li><h4>将dede网站根目录下的uploads移动到极致CMS网站根目录</h4></li>';
		echo '<li><h4>访问网站检查是否成功。。。<a href="/" target="_blank">【点击进入前台】</a><br>检查数据库是否导入。。。<a href="/admin.php" target="_blank">【点击进入后台】</a> 默认账户：admin  默认密码：admin </h4></li>';
		echo '<li><h4>值得注意的是：内容里面的图片还是原网站的，没关系，只要把当前极致CMS的网站绑定原网址即可，这样就转换过来了。</h4></li>';
		echo '<li><h4>完。</h4></li>';
		echo '</ol></div>';
		echo '<br/>';
		echo '<br/>';
		echo '<br/>';
		echo '<br/>';
		echo '<br/>';
		echo '<br/>';
		echo '<br/>';
	}
	
	function connectmysql(){
		$config  = $this->config;
        $db = new \DB_API($config);
		//echo '数据库连接成功！';
		Redirect(U('index/index'),'数据库连接成功！3s后回到首页...',3);
	}
	
	function clearlanmu(){
		$sql = 'truncate '.DB_PREFIX.'classtype';
        M()->runSql($sql);
		setCache('classtypetree',null);
		setCache('classtype',null);
		setCache('mobileclasstype',null); 
		Redirect(U('index/index'),'已清空数据表，2s后回到首页',2);
	}
	
	function clearbody(){
		$sql = 'truncate '.DB_PREFIX.'article';
        M()->runSql($sql);
        $_SESSION['insert_page'] = null;
        Redirect(U('index/index'),'已清空数据表，2s后回到首页',2);
	}
	
	//处理栏目--先去掉  exit;
	
    function lanmu(){
        
		
         //配置一个数据库
        $config  = $this->config;
        
        $db = new \DB_API($config);
        $lanmu = $db->set_table('arctype');
        $list = $lanmu->findAll();
        foreach($list as $v){
            $w = [];
            $w = $v;
            
            $w['classname']  = $v['typename'];
            $w['seo_classname'] = $v['seotitle'];
           // $w['htmlurl'] = str_replace(' ','',pinyin($v['typename']));
           $w['htmlurl'] = str_replace('{cmspath}/','',$v['typedir']);
           if(stripos($w['htmlurl'],'http')!==false){
               $w['gourl'] = $w['htmlurl'];
               $w['htmlurl'] =  str_replace(' ','',pinyin($v['typename']));
           }
            $w['pid'] = $v['reid'];
            $w['molds'] = 'article';
            $w['id'] = $v['id'];
            $w['lists_num'] = 12;
            
            $w['body'] = format_param($v['content'],4);
             $w['lists_html'] = 'article-list';
             $w['details_html'] = 'article-details';
            
            $r = M('classtype')->add($w);
            if($r){
				echo '<h3>栏目ID:'.$w['id'].' 栏目名: '.$w['classname'].'导入成功！</h3><br>';
			}else{
				echo '<h3 style="color:#f00">栏目ID:'.$w['id'].' 栏目名: '.$w['classname'].'导入失败！</h3><br>';
			}
            
        }
        
        setCache('classtypetree',null);
		setCache('classtype',null);
		setCache('mobileclasstype',null);
        echo '<h3>导入完成！</h3>';
		echo '<a href="/index/index"><h3>【点击返回首页】</h3></a>';
        
    }

   //文章处理  先去掉exit
    function body(){
        //配置一个数据库
        $config  = $this->config;
        $db = new \DB_API($config);
        //将传入表数据的对象类放入一个变量中，方便多次使用
        $article = $db->set_table('archives');
		if(!isset($_SESSION['insert_page'])){
			$_SESSION['insert_page'] = 0;
		}
		$num = $_SESSION['insert_page']*500;
		$limit = $num.',500';
        $lists = $article ->findAll(null,null,null,$limit);
		$i = 0;
        foreach($lists as $v){
              $w = $v;
              $w['title'] = addslashes($v['title']);
              $w['description'] = addslashes($v['description']);
              $w['htmlurl'] = $this->classtypedata[$v['typeid']]['htmlurl'];
              $w['tid'] = $v['typeid'];
              $w['seo_title'] = $w['title'];
              $w['molds'] = 'article';
              $w['litpic'] = $v['litpic'];
              $w['addtime'] = $v['pubdate'];
              $w['hits'] = $v['click'];
              $content = $db->set_table('addonarticle');
              $cont = $content->find(['aid'=>$v['id']]);
              $w['body'] = addslashes($cont['body']);
              $r = M('article')->add($w);
			if($r){
				echo '<h3 >成功导入内容ID:'.$r.' 标题: '.$w['title'].'</h3><br>';
			}else{
				echo '<h3 style="color:#f00">未导入ID:'.$v['id'].' 标题: '.$w['title'].'</h3><br>';
			}
			$i++;
             
        }
		if($i==500){
			$_SESSION['insert_page'] += 1;
			Redirect(U('index/body'),'正在导入下一页，请稍等....',2);
		}else{
			$_SESSION['insert_page'] = null;
			echo '<h3 >已全部处理完毕！</h3><a href="/index/index"><h3>【点击返回首页】</h3></a>';
		}
        
        
    }
    
   

    
    
}


